package com.railway.web.controller.system;

import com.railway.common.annotation.Log;
import com.railway.common.annotation.RepeatSubmit;
import com.railway.common.constant.UserConstants;
import com.railway.common.core.controller.BaseController;
import com.railway.common.core.domain.AjaxResult;
import com.railway.common.core.page.TableDataInfo;
import com.railway.common.enums.BusinessType;
import com.railway.common.utils.poi.ExcelUtil;
import com.railway.system.domain.SysConfig;
import com.railway.system.service.ISysConfigService;
import com.railway.system.service.ISysFileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.List;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 参数配置 信息操作处理
 *
 * @author railway
 */
@Api(tags = "参数配置")
@RestController
@RequestMapping("/system/config")
public class SysConfigController extends BaseController {

  private final ISysConfigService configService;
  private final ISysFileService sysFileService;

  public SysConfigController(ISysConfigService configService,
      ISysFileService sysFileService) {
    this.configService = configService;
    this.sysFileService = sysFileService;
  }

  /**
   * 获取参数配置列表
   */
  @ApiOperation(value = "获取参数配置列表")
  @PreAuthorize("@ss.hasPermi('system:config:list')")
  @GetMapping("/list")
  public TableDataInfo list(SysConfig config) {
    startPage();
    List<SysConfig> list = configService.selectConfigList(config);
    return getDataTable(list);
  }

  @Log(title = "参数管理", businessType = BusinessType.EXPORT)
  @PreAuthorize("@ss.hasPermi('system:config:export')")
  @GetMapping("/export")
  public AjaxResult export(SysConfig config) {
    List<SysConfig> list = configService.selectConfigList(config);
    ExcelUtil<SysConfig> util = new ExcelUtil<>(SysConfig.class);
    String localFilePath = util.exportExcel(list, "参数数据");
    return sysFileService.uploadFile(localFilePath);
  }

  /**
   * 根据参数编号获取详细信息
   */
  @PreAuthorize("@ss.hasPermi('system:config:query')")
  @GetMapping(value = "/{configId}")
  public AjaxResult getInfo(@PathVariable Long configId) {
    return AjaxResult.success(configService.selectConfigById(configId));
  }

  /**
   * 根据参数键名查询参数值
   */
  @ApiOperation(value = "根据参数键名查询参数值")
  @GetMapping(value = "/configKey/{configKey}")
  public AjaxResult getConfigKey(@PathVariable String configKey) {
    return AjaxResult.success(configService.selectConfigByKey(configKey));
  }

  /**
   * 新增参数配置
   */
  @PreAuthorize("@ss.hasPermi('system:config:add')")
  @Log(title = "参数管理", businessType = BusinessType.INSERT)
  @PostMapping
  @RepeatSubmit
  public AjaxResult add(@Validated @RequestBody SysConfig config) {
    if (UserConstants.NOT_UNIQUE.equals(configService.checkConfigKeyUnique(config))) {
      return AjaxResult.error("新增参数'" + config.getConfigName() + "'失败，参数键名已存在");
    }
    config.setCreateBy(getUsername());
    return toAjax(configService.insertConfig(config));
  }

  /**
   * 修改参数配置
   */
  @ApiOperation(value = "修改参数配置")
  @PreAuthorize("@ss.hasPermi('system:config:edit')")
  @Log(title = "参数管理", businessType = BusinessType.UPDATE)
  @PutMapping
  public AjaxResult edit(@Validated @RequestBody SysConfig config) {
    if (UserConstants.NOT_UNIQUE.equals(configService.checkConfigKeyUnique(config))) {
      return AjaxResult.error("修改参数'" + config.getConfigName() + "'失败，参数键名已存在");
    }
    config.setUpdateBy(getUsername());
    return toAjax(configService.updateConfig(config));
  }

  /**
   * 删除参数配置
   */
  @PreAuthorize("@ss.hasPermi('system:config:remove')")
  @Log(title = "参数管理", businessType = BusinessType.DELETE)
  @DeleteMapping("/{configIds}")
  public AjaxResult remove(@PathVariable Long[] configIds) {
    configService.deleteConfigByIds(configIds);
    return success();
  }

  /**
   * 刷新参数缓存
   */
  @ApiOperation(value = "刷新参数缓存")
  @PreAuthorize("@ss.hasPermi('system:config:remove')")
  @Log(title = "参数管理", businessType = BusinessType.CLEAN)
  @DeleteMapping("/refreshCache")
  public AjaxResult refreshCache() {
    configService.resetConfigCache();
    return AjaxResult.success();
  }
}
